"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.OneToMany = exports.OneToOne = void 0;
require("reflect-metadata");
const OneToOne = (options) => {
    return (target, property) => {
        const metadata = Reflect.getMetadata('JSONAPI_ONE_TO_ONE', target.constructor) || {};
        metadata[property] = options;
        Reflect.defineMetadata('JSONAPI_ONE_TO_ONE', metadata, target.constructor);
    };
};
exports.OneToOne = OneToOne;
const OneToMany = (options) => {
    return (target, property) => {
        const metadata = Reflect.getMetadata('JSONAPI_ONE_TO_MANY', target.constructor) || {};
        metadata[property] = options;
        Reflect.defineMetadata('JSONAPI_ONE_TO_MANY', metadata, target.constructor);
    };
};
exports.OneToMany = OneToMany;
//# sourceMappingURL=relationship.decorator.js.map