import { Observable } from 'rxjs';
import { CallHandler, ExecutionContext, NestInterceptor } from '@nestjs/common';
import { EntityType } from '../types/entity.type';
import { Serializable } from '../interfaces/serializable.interface';
import { Document, MetaObject } from '../interfaces/document.interface';
export interface EntitySerializerOptions<T extends Serializable> {
    entity: EntityType<T>;
    jsonapi?: {
        meta?: MetaObject;
        include?: boolean;
    };
}
export declare class EntitySerializerInterceptor<T extends Serializable> implements NestInterceptor<T, Document<T>> {
    private options;
    constructor(options: EntitySerializerOptions<T>);
    intercept(context: ExecutionContext, next: CallHandler): Observable<Document<T>>;
    private createData;
    private createJSONAPI;
}
//# sourceMappingURL=entity-serializer.interceptor.d.ts.map