"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.EntitySerializerInterceptor = void 0;
const operators_1 = require("rxjs/operators");
const common_1 = require("@nestjs/common");
const resource_serializer_1 = require("../serializers/resource.serializer");
let EntitySerializerInterceptor = class EntitySerializerInterceptor {
    constructor(options) {
        this.options = options;
    }
    intercept(context, next) {
        return next.handle().pipe(operators_1.map(data => {
            var _a;
            const document = {};
            document.data = this.createData(data);
            if (((_a = this.options.jsonapi) === null || _a === void 0 ? void 0 : _a.include) !== false) {
                document.jsonapi = this.createJSONAPI();
            }
            return document;
        }));
    }
    ;
    createData(data) {
        const serializer = new resource_serializer_1.ResourceSerializer(this.options);
        if (!Array.isArray(data)) {
            return serializer.parseOne(data);
        }
        else {
            return serializer.parseMany(data);
        }
    }
    createJSONAPI() {
        var _a;
        return {
            version: '1.0',
            meta: (_a = this.options.jsonapi) === null || _a === void 0 ? void 0 : _a.meta,
        };
    }
};
EntitySerializerInterceptor = __decorate([
    common_1.Injectable(),
    __metadata("design:paramtypes", [Object])
], EntitySerializerInterceptor);
exports.EntitySerializerInterceptor = EntitySerializerInterceptor;
//# sourceMappingURL=entity-serializer.interceptor.js.map