import 'reflect-metadata';

export type RelationshipOptions = {
  name: string;
}

export const OneToOne = (options: RelationshipOptions): PropertyDecorator => {
  return (target: Object, property: string | symbol) => {
    const metadata = Reflect.getMetadata('JSONAPI_ONE_TO_ONE', target.constructor) || {};
    metadata[property] = options;
    Reflect.defineMetadata('JSONAPI_ONE_TO_ONE', metadata, target.constructor);
  };
};

export const OneToMany = (options: RelationshipOptions): PropertyDecorator => {
  return (target: Object, property: string | symbol) => {
    const metadata = Reflect.getMetadata('JSONAPI_ONE_TO_MANY', target.constructor) || {};
    metadata[property] = options;
    Reflect.defineMetadata('JSONAPI_ONE_TO_MANY', metadata, target.constructor);
  };
};